(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* Class for question06      *)

let (count, get_count) =
  let c = ref 0 in
  ((fun () -> incr c), (fun () -> !c))

class virtual vnode (k:int) (v:int) =
object
  val key = k
  method get_key =
    count (); key
  method get_value = v
  method virtual left : vnode option
  method virtual right : vnode option
  method virtual print : unit
end

class node k v l r =
object
  inherit vnode k v
  method left = Some l
  method right = Some r

  method print =
    begin
      Format.printf "@,@[<v 2>Node: (%d,%d)" key v;
      l#print;
      r#print;
      Format.printf "@]";
    end

end

class leaf k v =
object
  inherit vnode k v
  method left = None
  method right = None
  method print =
    Format.printf "@,@[<h>Leaf: (%d,%d)@]" key v;
end

let rec factory down up = function
  | 0
    -> (new leaf (down + Random.int (up - down))) (Random.int 1000)
  | h
    ->
    let k =
      ((down + (up - down)/2) - ((up - down)/4) + Random.int ((up - down)/2))
    in
      new node k (Random.int 1000)
        (factory down (k-1) (h-1))
        (factory (k+1) up (h-1))
