class virtual noel =
object (s)
  val mutable f = 0.
  val mutable scaleX = 400.
  val mutable scaleY = 400.
  val mutable vx = 1.
  val mutable vy = 0.
  val rr = (acos (-1.))/.3.

  method virtual iter : float -> int -> unit

  method private convX fx = int_of_float (scaleX *. fx)
  method private convY fy = int_of_float (scaleY *. fy)

  method comet l =
    let (dx, dy) =
      (s#convX (l *. vx), s#convY (l *. vy))
    in
      f <- f +. l;
      Graphics.rlineto dx dy

  method dasher x =
    let r = x *. rr in
    let vx' = vx *. cos r -. vy *. sin r in
    let vy' = vx *. sin r +. vy *. cos r in
      vx <- vx';
      vy <- vy'

  method rudolph n =
    begin
      Graphics.open_graph " 512x512";
      Graphics.clear_graph ();
      Graphics.moveto 56 346;
      s#iter  1. n;
      s#dasher (-2.);
      s#iter 1. n;
      s#dasher (-2.);
      s#iter 1. n;
      Printf.printf "Santa Claus travels for %f km.\n" f;
      Printf.printf "Press any key.\n";
      flush stdout;
      ignore (Graphics.read_key ());
      Printf.printf "Joyeux Noël %s !\n" (Sys.getenv "USER");
    end

end
