(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question08                *)

type register =
{
  mutable pc     : int;
  mutable count  : int;
  data           : int array;
  mutable result : int;
}

type instr =
  | LOAD of int * int
  | MOVE of int * int
  | SET of int
  | INCR
  | DECR
  | JMP of int
  | BCZR of int
  | BRZR of int * int
  | ADD of int * int * int
  | MIN of int * int * int
  | MUL of int * int * int
  | DIV of int * int * int
  | RET of int

let eval reg inst =
  begin
    match inst.(reg.pc) with
      | LOAD(x,r) ->
	  reg.data.(r) <- x
      | MOVE(r1,r2) ->
	  reg.data.(r2) <- reg.data.(r1)
      | SET r ->
	  reg.count <- reg.data.(r)
      | INCR ->
	  reg.count <- reg.count + 1
      | DECR ->
	  reg.count <- reg.count - 1
      | JMP l ->
	  reg.pc <- l - 1
      | BCZR l ->
	  if reg.count = 0 then
	    reg.pc <- l - 1
      | BRZR (r,l) ->
	  if reg.data.(r) = 0 then
	    reg.pc <- l - 1
      | ADD (r1,r2,r3) ->
	  reg.data.(r3) <- reg.data.(r1) + reg.data.(r2)
      | MIN (r1,r2,r3) ->
	  reg.data.(r3) <- reg.data.(r1) - reg.data.(r2)
      | MUL (r1,r2,r3) ->
	  reg.data.(r3) <- reg.data.(r1) * reg.data.(r2)
      | DIV (r1,r2,r3) ->
	  reg.data.(r3) <- reg.data.(r1) / reg.data.(r2)
      | RET r ->
	  reg.result <- reg.data.(r);
	  reg.pc <- -2
  end;
  reg.pc <- reg.pc + 1

let exec inst =
  let reg =
    {
      pc = 0;
      count = 0;
      data = Array.make 16 0;
      result = 0;
    }
  in
    while reg.pc >= 0 do
      eval reg inst;
    done;
    reg

