(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question09                *)

module type OrderedType =
sig
  type t
  val compare : t -> t -> int
end

module type BOX =
sig
  type content
  type t
  val create : content -> t
  val update : t -> content -> unit
  val get : t -> content
end

module MaxBox (T:OrderedType) =
struct
  type content = T.t
  type t = {
    mutable content : content;
  }

  let create v = { content = v; }

  let update box v =
    if T.compare v box.content >= 0 then
      box.content <- v

  let get box = box.content

end
