module type OrderedType = sig type t val compare : t -> t -> int end

module type BOX =
  sig
    type content
    type t
    val create : content -> t
    val update : t -> content -> unit
    val get : t -> content
  end

module MaxBox :
  functor (T : OrderedType) -> BOX with type content = T.t
