(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question07                *)

module Q = Question07

let rec gen_num q = function
  | 0 -> Q.Zero
  | n ->
    let r = q#getN in
      if r < 1000/n then Q.Zero
      else
        if r < 3500 then Q.Succ (gen_num q (n-1))
        else Q.Pred (gen_num q (n-1))

let rec printer = function
  | Q.Zero -> Format.printf "@[<h>Zero@]"
  | Q.Succ a
    ->
    begin
      Format.printf "@[<b 2>Succ(@[<b -2>@,";
      printer a;
      Format.printf "@]@,)@]"
    end
  | Q.Pred a
    ->
    begin
      Format.printf "@[<b 2>Pred(@[<b -2>@,";
      printer a;
      Format.printf "@]@,)@]"
    end

let canon n =
  let rec split (s,p) = function
    | Q.Zero -> (s,p)
    | Q.Succ a -> split (1::s,p) a
    | Q.Pred a -> split (s,1::p) a
  in
  let rec rejoin accu = function
    | ([],[]) -> accu
    | ([],_::t)
      -> rejoin (Q.Pred accu) ([],t)
    | (_::t,[])
      -> rejoin (Q.Succ accu) (t,[])
    | (_::ts,_::tp)
      -> rejoin accu (ts,tp)
  in
    rejoin Q.Zero (split ([],[]) n)

let main () =
  begin
    let q = new Test_frame.qSeedTwoSizeInt 7 6000 in
      q#beginParse;
      q#init;
      for i = 1 to q#get_size2 do
        let a = gen_num q q#get_size1 in
        let b = gen_num q q#get_size1 in
          Format.printf "@[<v 2>a =@,";
          printer a;
          Format.printf "@]@.@[<v 2>b =@,";
          printer b;
          Format.printf "@]@.";
          Format.printf "@[<v 2>a + b =@,";
          printer (canon (Q.add a b));
          Format.printf "@]@.";
          Format.printf "@.";
      done;
      exit 0
  end

let _ = main ()
