(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question10                *)

module Q = Question10

let rec build_img q = function
  | 0 ->
    if Random.bool () then Q.White
    else Q.Black
  | n
    ->
    begin
      let r = q#getN in
        if r < 1000/n then
          if r mod 2 = 0 then
            Q.Composed ( Q.White, Q.White, Q.White, Q.White)
          else
            Q.Composed ( Q.Black, Q.Black, Q.Black, Q.Black)
        else
          Q.Composed (
            build_img q (n-1),
            build_img q (n-1),
            build_img q (n-1),
            build_img q (n-1)
          )
    end

let rec print_img = function
  | Q.White -> Format.printf "@[<h>White@]"
  | Q.Black -> Format.printf "@[<h>Black@]"
  | Q.Composed(i0,i1,i2,i3)
    ->
    begin
      Format.printf "@,@[<b>Composed(@[<b -7>";
      print_img i0;
      Format.printf ",@;";
      print_img i1;
      Format.printf ",@;";
      print_img i2;
      Format.printf ",@;";
      print_img i3;
      Format.printf "@]@,)@]";
    end

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 10 1000 in
      q#beginParse;
      q#init;
      let img = build_img q q#getSize in
        Format.printf "@[<b 2>img =@;";
        print_img img;
        Format.printf "@]@.";
        Format.printf "@[<b 2>simplify img =@;";
        print_img (Q.simplify img);
        Format.printf "@]@.";
        exit 0;
  end

let _ = main ()
